// Класс поисковой формы
function cSearch() {
    this._jSearchResultContainer = $('.SearchResult');
    this._jTemplateContainer = $("#resultPrototype");
    this._jSearchButton = $(".searchBtn");
    this._Template = this._jTemplateContainer.html();
    this.Handler = "";

    // Замыкание
    var self = this;

    // Ответ, который получает сервер
    this._Response = {};

    // Get data from server
    this.Load = function (Handler, Data) {
        $.post(Handler, Data, function (response) {
            self._jSearchResultContainer.html("");
            $.each(response, function(i) {
                if(i > 10) return;
                self._jSearchResultContainer.append(
                    Mustache.render(self._Template, response[i])
                );
            });
        }, "json");
    };

    this.Init = function (Handler) {
        this._jTemplateContainer.html("");
        Mustache.parse(this._Template);
        this._EventsLinker();
        self.Handler = Handler;
    };

    this._EventsLinker = function()
    {
        // Привязываем кнопку поиска
        self._jSearchButton.click(self.Search());
        self.EventsLinker();
    };

    // Should be implemented by child classes
    this.Search = function () {};
    this.EventsLinker = function () {};
}

function SearchStudent(jName, jFacultySelect, jGradeSelect, jGroupSelect) {
    cSearch.call(this);

    this.Handler = "";
    var self = this;
    this.AdditionalRequestParams = {};
    this.Search = function () {
        var Request = $.extend(true, {
            'Name': jName.val(),
            'FacultyID': jFacultySelect.find('option:selected').val(),
            'GradeID': jGradeSelect.find('option:selected').val(),
            'GroupID': jGroupSelect.find('option:selected').val()
        }, self.AdditionalRequestParams);
        self.Load(self.Handler, Request);
    };

    this.EventsLinker = function() {
        jName.change(this.Search);
        jFacultySelect.change(this.Search);
        jGradeSelect.change(this.Search);
        jGroupSelect.change(this.Search);
    }
}

function SearchTeacher(jName, jFacultySelect, jDepartmentSelect) {
    cSearch.call(this);

    this.Handler = "";
    var self = this;
    this.AdditionalRequestParams = {};
    this.Search = function () {
        var Request = $.extend(true, {
            'Name': jName.val(),
            'FacultyID': jFacultySelect.find('option:selected').val(),
            'DepartmentID': jDepartmentSelect.find('option:selected').val()
        }, self.AdditionalRequestParams);
        self.Load(self.Handler, Request);
    };

    this.EventsLinker = function() {
        jName.change(this.Search);
        jFacultySelect.change(this.Search);
        jDepartmentSelect.change(this.Search);
    }
}
